module alu4(a,b,GS,cin,g,C,V);

	input [3:0] a, b;
	input [3:0] GS;
	input cin;
	output [3:0] g;
	output C, V;
	wire [3:0] cout, sum;
	reg [3:0] y;

	adder 
		ADD0(a[0],b[0],GS[2:1],cin,sum[0],cout[0]),
		ADD1(a[1],b[1],GS[2:1],cout[0],sum[1],cout[1]),
		ADD2(a[2],b[2],GS[2:1],cout[1],sum[2],cout[2]),
		ADD3(a[3],b[3],GS[2:1],cout[2],sum[3],cout[3]);
	assign C = cout[3];
	assign V = cout[2]^cout[3];	

	always
	case (GS[1:0])
	2'b00: y = a&b;
	2'b01: y = a|b;
	2'b10: y = a^b;
	2'b11: y = ~a;
	endcase
		
	assign g = (GS[3]? y: sum);
endmodule

