module reg_file(clk, enable_write, AA, BA, DA, A, B, D);
parameter width = 16;
input clk, enable_write;
input [2:0] AA, BA, DA;
input [width-1:0] D;
output [width-1:0] A, B;
reg [width-1: 0] A, B;

reg [width-1:0] R0, R1, R2, R3, R4, R5, R6, R7; // eight 16-bit registers

always @ (posedge clk)
   if (enable_write) 
   	case (DA)
   	0: R0 <= D;
   	1: R1 <= D;
   	2: R2 <= D;
   	3: R3 <= D;
   	4: R4 <= D;
   	5: R5 <= D;
   	6: R6 <= D;
   	7: R7 <= D;
   	endcase
always
begin
   	case (BA)
   	0: B <= R0;
   	1: B <= R1;
   	2: B <= R2;
   	3: B <= R3;
   	4: B <= R4;
   	5: B <= R5;
   	6: B <= R6;
   	7: B <= R7;
   	endcase
   	case (AA)
   	0: A <= R0;
   	1: A <= R1;
   	2: A <= R2;
   	3: A <= R3;
    4: A <= R4;
   	5: A <= R5;
   	6: A <= R6;
   	7: A <= R7;
   	endcase
 end

endmodule
